curl: remove compatibility code, require 7.29.0
[qemu/ar7.git] / Makefile
blobfb9923ff220ab8290325c35780eeada518935b09
1 # Makefile for QEMU.
3 ifneq ($(words $(subst :, ,$(CURDIR))), 1)
4 $(error main directory cannot contain spaces nor colons)
5 endif
7 # Always point to the root of the build tree (needs GNU make).
8 BUILD_DIR=$(CURDIR)
10 # Before including a proper config-host.mak, assume we are in the source tree
11 SRC_PATH=.
13 # Don't use implicit rules or variables
14 # we have explicit rules for everything
15 MAKEFLAGS += -rR
17 SHELL = /usr/bin/env bash -o pipefail
19 # Usage: $(call quiet-command,command and args,"NAME","args to print")
20 # This will run "command and args", and either:
21 # if V=1 just print the whole command and args
22 # otherwise print the 'quiet' output in the format " NAME args to print"
23 # NAME should be a short name of the command, 7 letters or fewer.
24 # If called with only a single argument, will print nothing in quiet mode.
25 quiet-command-run = $(if $(V),,$(if $2,printf " %-7s %s\n" $2 $3 && ))$1
26 quiet-@ = $(if $(V),,@)
27 quiet-command = $(quiet-@)$(call quiet-command-run,$1,$2,$3)
29 UNCHECKED_GOALS := %clean TAGS cscope ctags dist \
30 help check-help print-% \
31 docker docker-% vm-help vm-test vm-build-%
33 all:
34 .PHONY: all clean distclean recurse-all dist msi FORCE
36 # Don't try to regenerate Makefile or configure
37 # We don't generate any of them
38 Makefile: ;
39 configure: ;
41 # All following code might depend on configuration variables
42 ifneq ($(wildcard config-host.mak),)
43 include config-host.mak
45 git-submodule-update:
46 .git-submodule-status: git-submodule-update config-host.mak
47 Makefile: .git-submodule-status
49 .PHONY: git-submodule-update
51 git_module_status := $(shell \
52 cd '$(SRC_PATH)' && \
53 GIT="$(GIT)" ./scripts/git-submodule.sh status $(GIT_SUBMODULES); \
54 echo $$?; \
57 ifeq (1,$(git_module_status))
58 ifeq (no,$(GIT_UPDATE))
59 git-submodule-update:
60 $(call quiet-command, \
61 echo && \
62 echo "GIT submodule checkout is out of date. Please run" && \
63 echo " scripts/git-submodule.sh update $(GIT_SUBMODULES)" && \
64 echo "from the source directory checkout $(SRC_PATH)" && \
65 echo && \
66 exit 1)
67 else
68 git-submodule-update:
69 $(call quiet-command, \
70 (cd $(SRC_PATH) && GIT="$(GIT)" ./scripts/git-submodule.sh update $(GIT_SUBMODULES)), \
71 "GIT","$(GIT_SUBMODULES)")
72 endif
73 endif
75 # 0. ensure the build tree is okay
77 # Check that we're not trying to do an out-of-tree build from
78 # a tree that's been used for an in-tree build.
79 ifneq ($(realpath $(SRC_PATH)),$(realpath .))
80 ifneq ($(wildcard $(SRC_PATH)/config-host.mak),)
81 $(error This is an out of tree build but your source tree ($(SRC_PATH)) \
82 seems to have been used for an in-tree build. You can fix this by running \
83 "$(MAKE) distclean && rm -rf *-linux-user *-softmmu" in your source tree)
84 endif
85 endif
87 # force a rerun of configure if config-host.mak is too old or corrupted
88 ifeq ($(MESON),)
89 .PHONY: config-host.mak
90 x := $(shell rm -rf meson-private meson-info meson-logs)
91 endif
92 ifeq ($(NINJA),)
93 .PHONY: config-host.mak
94 x := $(shell rm -rf meson-private meson-info meson-logs)
95 else
96 export NINJA
97 endif
98 ifeq ($(wildcard build.ninja),)
99 .PHONY: config-host.mak
100 x := $(shell rm -rf meson-private meson-info meson-logs)
101 endif
102 ifeq ($(origin prefix),file)
103 .PHONY: config-host.mak
104 x := $(shell rm -rf meson-private meson-info meson-logs)
105 endif
107 # 1. ensure config-host.mak is up-to-date
108 config-host.mak: $(SRC_PATH)/configure $(SRC_PATH)/pc-bios $(SRC_PATH)/VERSION
109 @echo config-host.mak is out-of-date, running configure
110 @if test -f meson-private/coredata.dat; then \
111 ./config.status --skip-meson; \
112 else \
113 ./config.status && touch build.ninja.stamp; \
116 # 2. meson.stamp exists if meson has run at least once (so ninja reconfigure
117 # works), but otherwise never needs to be updated
118 meson-private/coredata.dat: meson.stamp
119 meson.stamp: config-host.mak
120 @touch meson.stamp
122 # 3. ensure generated build files are up-to-date
124 ifneq ($(NINJA),)
125 Makefile.ninja: build.ninja
126 $(quiet-@){ \
127 echo 'ninja-targets = \'; \
128 $(NINJA) -t targets all | sed 's/:.*//; $$!s/$$/ \\/'; \
129 echo 'build-files = \'; \
130 $(NINJA) -t query build.ninja | sed -n '1,/^ input:/d; /^ outputs:/q; s/$$/ \\/p'; \
131 } > $@.tmp && mv $@.tmp $@
132 -include Makefile.ninja
134 # A separate rule is needed for Makefile dependencies to avoid -n
135 build.ninja: build.ninja.stamp
136 $(build-files):
137 build.ninja.stamp: meson.stamp $(build-files)
138 $(NINJA) $(if $V,-v,) build.ninja && touch $@
139 endif
141 ifneq ($(MESON),)
142 Makefile.mtest: build.ninja scripts/mtest2make.py
143 $(MESON) introspect --targets --tests --benchmarks | $(PYTHON) scripts/mtest2make.py > $@
144 -include Makefile.mtest
145 endif
147 # 4. Rules to bridge to other makefiles
149 ifneq ($(NINJA),)
150 MAKE.n = $(findstring n,$(firstword $(MAKEFLAGS)))
151 MAKE.k = $(findstring k,$(firstword $(MAKEFLAGS)))
152 MAKE.q = $(findstring q,$(firstword $(MAKEFLAGS)))
153 MAKE.nq = $(if $(word 2, $(MAKE.n) $(MAKE.q)),nq)
154 NINJAFLAGS = $(if $V,-v) $(if $(MAKE.n), -n) $(if $(MAKE.k), -k0) \
155 $(filter-out -j, $(lastword -j1 $(filter -l% -j%, $(MAKEFLAGS)))) \
157 ninja-cmd-goals = $(or $(MAKECMDGOALS), all)
158 ninja-cmd-goals += $(foreach t, $(.tests), $(.test.deps.$t))
160 makefile-targets := build.ninja ctags TAGS cscope dist clean uninstall
161 # "ninja -t targets" also lists all prerequisites. If build system
162 # files are marked as PHONY, however, Make will always try to execute
163 # "ninja build.ninja".
164 ninja-targets := $(filter-out $(build-files) $(makefile-targets), $(ninja-targets))
165 .PHONY: $(ninja-targets) run-ninja
166 $(ninja-targets): run-ninja
168 # Use "| cat" to give Ninja a more "make-y" output. Use "+" to bypass the
169 # --output-sync line.
170 run-ninja: config-host.mak
171 ifneq ($(filter $(ninja-targets), $(ninja-cmd-goals)),)
172 +$(quiet-@)$(if $(MAKE.nq),@:, $(NINJA) \
173 $(NINJAFLAGS) $(sort $(filter $(ninja-targets), $(ninja-cmd-goals))) | cat)
174 endif
175 endif
177 # Force configure to re-run if the API symbols are updated
178 ifeq ($(CONFIG_PLUGIN),y)
179 config-host.mak: $(SRC_PATH)/plugins/qemu-plugins.symbols
181 .PHONY: plugins
182 plugins:
183 $(call quiet-command,\
184 $(MAKE) $(SUBDIR_MAKEFLAGS) -C contrib/plugins V="$(V)", \
185 "BUILD", "example plugins")
186 endif # $(CONFIG_PLUGIN)
188 else # config-host.mak does not exist
189 config-host.mak:
190 ifneq ($(filter-out $(UNCHECKED_GOALS),$(MAKECMDGOALS)),$(if $(MAKECMDGOALS),,fail))
191 @echo "Please call configure before running make!"
192 @exit 1
193 endif
194 endif # config-host.mak does not exist
196 SUBDIR_MAKEFLAGS=$(if $(V),,--no-print-directory --quiet)
198 include $(SRC_PATH)/tests/Makefile.include
200 all: recurse-all
202 ROM_DIRS = $(addprefix pc-bios/, $(ROMS))
203 ROM_DIRS_RULES=$(foreach t, all clean, $(addsuffix /$(t), $(ROM_DIRS)))
204 # Only keep -O and -g cflags
205 .PHONY: $(ROM_DIRS_RULES)
206 $(ROM_DIRS_RULES):
207 $(call quiet-command,$(MAKE) $(SUBDIR_MAKEFLAGS) -C $(dir $@) V="$(V)" TARGET_DIR="$(dir $@)" $(notdir $@),)
209 .PHONY: recurse-all recurse-clean
210 recurse-all: $(addsuffix /all, $(ROM_DIRS))
211 recurse-clean: $(addsuffix /clean, $(ROM_DIRS))
213 ######################################################################
215 clean: recurse-clean
216 -$(quiet-@)test -f build.ninja && $(NINJA) $(NINJAFLAGS) -t clean || :
217 -$(quiet-@)test -f build.ninja && $(NINJA) $(NINJAFLAGS) clean-ctlist || :
218 # avoid old build problems by removing potentially incorrect old files
219 rm -f config.mak op-i386.h opc-i386.h gen-op-i386.h op-arm.h opc-arm.h gen-op-arm.h
220 find . \( -name '*.so' -o -name '*.dll' -o -name '*.[oda]' \) -type f \
221 ! -path ./roms/edk2/ArmPkg/Library/GccLto/liblto-aarch64.a \
222 ! -path ./roms/edk2/ArmPkg/Library/GccLto/liblto-arm.a \
223 -exec rm {} +
224 rm -f TAGS cscope.* *.pod *~ */*~
225 rm -f fsdev/*.pod scsi/*.pod
227 VERSION = $(shell cat $(SRC_PATH)/VERSION)
229 dist: qemu-$(VERSION).tar.bz2
231 qemu-%.tar.bz2:
232 $(SRC_PATH)/scripts/make-release "$(SRC_PATH)" "$(patsubst qemu-%.tar.bz2,%,$@)"
234 distclean: clean
235 -$(quiet-@)test -f build.ninja && $(NINJA) $(NINJAFLAGS) -t clean -g || :
236 rm -f config-host.mak config-host.h*
237 rm -f tests/tcg/config-*.mak
238 rm -f config-all-disas.mak config.status
239 rm -f tests/qemu-iotests/common.env
240 rm -f roms/seabios/config.mak roms/vgabios/config.mak
241 rm -f qemu-plugins-ld.symbols qemu-plugins-ld64.symbols
242 rm -f *-config-target.h *-config-devices.mak *-config-devices.h
243 rm -rf meson-private meson-logs meson-info compile_commands.json
244 rm -f Makefile.ninja Makefile.mtest build.ninja.stamp meson.stamp
245 rm -f config.log
246 rm -f linux-headers/asm
247 rm -Rf .sdk
249 find-src-path = find "$(SRC_PATH)/" -path "$(SRC_PATH)/meson" -prune -o \( -name "*.[chsS]" -o -name "*.[ch].inc" \)
251 .PHONY: ctags
252 ctags:
253 rm -f "$(SRC_PATH)/"tags
254 $(find-src-path) -exec ctags -f "$(SRC_PATH)/"tags --append {} +
256 .PHONY: TAGS
257 TAGS:
258 rm -f "$(SRC_PATH)/"TAGS
259 $(find-src-path) -exec etags -f "$(SRC_PATH)/"TAGS --append {} +
261 .PHONY: cscope
262 cscope:
263 rm -f "$(SRC_PATH)"/cscope.*
264 $(find-src-path) -print | sed -e 's,^\./,,' > "$(SRC_PATH)/cscope.files"
265 cscope -b -i"$(SRC_PATH)/cscope.files" -f"$(SRC_PATH)"/cscope.out
267 # Needed by "meson install"
268 export DESTDIR
270 include $(SRC_PATH)/tests/docker/Makefile.include
271 include $(SRC_PATH)/tests/vm/Makefile.include
273 print-help-run = printf " %-30s - %s\\n" "$1" "$2"
274 print-help = @$(call print-help-run,$1,$2)
276 .PHONY: help
277 help:
278 @echo 'Generic targets:'
279 $(call print-help,all,Build all)
280 $(call print-help,dir/file.o,Build specified target only)
281 $(call print-help,install,Install QEMU, documentation and tools)
282 $(call print-help,ctags/TAGS,Generate tags file for editors)
283 $(call print-help,cscope,Generate cscope index)
284 $(call print-help,sparse,Run sparse on the QEMU source)
285 @echo ''
286 ifeq ($(CONFIG_PLUGIN),y)
287 @echo 'Plugin targets:'
288 $(call print-help,plugins,Build the example TCG plugins)
289 @echo ''
290 endif
291 @echo 'Cleaning targets:'
292 $(call print-help,clean,Remove most generated files but keep the config)
293 $(call print-help,distclean,Remove all generated files)
294 $(call print-help,dist,Build a distributable tarball)
295 @echo ''
296 @echo 'Test targets:'
297 $(call print-help,check,Run all tests (check-help for details))
298 $(call print-help,bench,Run all benchmarks)
299 $(call print-help,docker,Help about targets running tests inside containers)
300 $(call print-help,vm-help,Help about targets running tests inside VM)
301 @echo ''
302 @echo 'Documentation targets:'
303 $(call print-help,html man,Build documentation in specified format)
304 @echo ''
305 ifdef CONFIG_WIN32
306 @echo 'Windows targets:'
307 $(call print-help,installer,Build NSIS-based installer for QEMU)
308 ifdef CONFIG_QGA_MSI
309 $(call print-help,msi,Build MSI-based installer for qemu-ga)
310 endif
311 @echo ''
312 endif
313 $(call print-help,$(MAKE) [targets],(quiet build, default))
314 $(call print-help,$(MAKE) V=1 [targets],(verbose build))
316 # will delete the target of a rule if commands exit with a nonzero exit status
317 .DELETE_ON_ERROR:
319 print-%:
320 @echo '$*=$($*)'